// CustomizeDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "crystalcpuid.h"
#include "CrystalCPUIDDlg.h"
#include "CustomizeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int gLanguage;
extern CBitmap gBackBitmap;
extern CBrush gBackBrush;
extern COLORREF gTextColor;
extern BOOL gFlagBack;

static CCrystalCPUIDDlg* P;

/////////////////////////////////////////////////////////////////////////////
// CCustomizeDlg _CAO

CCustomizeDlg::CCustomizeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCustomizeDlg::IDD, pParent)
{
	P = (CCrystalCPUIDDlg*)pParent;
	P->GetClientRect(&m_rect);
	//{{AFX_DATA_INIT(CCustomizeDlg)
	m_FileName = _T("");
	m_WindowSize = _T("");
	m_ImageSize = _T("");
	m_TextColor = _T("");
	//}}AFX_DATA_INIT
}

void CCustomizeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCustomizeDlg)
	DDX_Text(pDX, IDC_FILE_NAME, m_FileName);
	DDX_Text(pDX, IDC_WINDOW_SIZE, m_WindowSize);
	DDX_Text(pDX, IDC_IMAGE_SIZE, m_ImageSize);
	DDX_Text(pDX, IDC_TEXT_COLOR, m_TextColor);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCustomizeDlg, CDialog)
	//{{AFX_MSG_MAP(CCustomizeDlg)
	ON_BN_CLICKED(IDC_SELECT_FILE, OnSelectFile)
	ON_BN_CLICKED(IDC_SELECT_COLOR, OnSelectColor)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomizeDlg bZ[W nh

void CCustomizeDlg::OnCancel() 
{
	OnOK();
//	CDialog::OnCancel();
}

void CCustomizeDlg::OnOK() 
{
//	UpdateData(FALSE);
	CDialog::OnOK();
}

void CCustomizeDlg::OnSelectFile() 
{
	CFileDialog dlg(TRUE,
		"","",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
#ifdef USEJPEG
		"Supported Image Files|*.bmp;*.png;*.jpg;*.jpeg|BMP (*.bmp)|*.bmp|PNG (*.png)|*.png|JPEG (*.jpg *.jpeg)|*.jpg;*.jpeg|All Files (*.*)|*.*||");
//#else USEPNG
//		"Supported Image File|*.bmp;*.png|BMP (*.bmp)|*.bmp|PNG (*.png)|*.png|All Files (*.*)|*.*||");
#else 
		"Supported Image Files|*.bmp|BMP (*.bmp)|*.bmp|All Files (*.*)|*.*||");
#endif
	if( dlg.DoModal() == IDOK )
	{
		m_FileName = dlg.GetPathName();
		if( Dib.LoadBmp(m_FileName) 
#ifdef USEPNG
			|| Dib.LoadPng(m_FileName) 
#endif
#ifdef USEJPEG
		|| Dib.LoadJpeg(m_FileName)
#endif
		)
		{
			m_ImageSize.Format("%d x %d", Dib.Width(), Dib.Height() ) ;
			Dib.Destroy();
		}
		UpdateData(FALSE);
		WritePrivateProfileString("Setting","BackgroundImage",m_FileName,P->m_ini);
		P->CreateWallPaper(1,NULL,(char*)(const char*)m_FileName,0);
		P->Invalidate();
	}
}

BOOL CCustomizeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	char str[256];
	GetPrivateProfileString("Setting","BackgroundImage","",str,256,P->m_ini);
	m_FileName = str;

	GetPrivateProfileString("Setting","TextColor","",str,256,P->m_ini);
	if( strcmp(str,"") == 0){
		gTextColor = ::GetSysColor(COLOR_WINDOWTEXT);
	}else{
		gTextColor = atoi(str);
	}
	m_TextColor.Format("RGB( %d, %d, %d )",
		gTextColor & 0x000000FF,
		(gTextColor & 0x0000FF00) >> 8,
		(gTextColor & 0x00FF0000) >> 16
		);
	
	if( ! m_FileName.IsEmpty() && ( Dib.LoadBmp(m_FileName)
#ifdef USEPNG
		|| Dib.LoadPng(m_FileName)
#endif
#ifdef USEJPEG
		|| Dib.LoadJpeg(m_FileName)
#endif
		)
	)
	{
		m_ImageSize.Format("%d x %d", Dib.Width(), Dib.Height()) ;
		Dib.Destroy();
	}

	m_WindowSize.Format("%d x %d", m_rect.right, m_rect.bottom);

	UpdateData(FALSE);

	return TRUE;
}

void CCustomizeDlg::OnSelectColor() 
{
	CColorDialog dlg;
	if( dlg.DoModal() == IDOK )
	{
		gTextColor = dlg.GetColor();
		m_TextColor.Format("RGB( %d, %d, %d )",
			gTextColor & 0x000000FF,
			(gTextColor & 0x0000FF00) >> 8,
			(gTextColor & 0x00FF0000) >> 16
			);
		UpdateData(FALSE);

		CString cstr;
		cstr.Format("%d",gTextColor);
		WritePrivateProfileString("Setting","TextColor",cstr,P->m_ini);
		P->Invalidate();
	}
}

void CCustomizeDlg::OnClear() 
{
	WritePrivateProfileString("Setting","BackgroundImage","",P->m_ini);
	WritePrivateProfileString("Setting","TextColor","",P->m_ini);
	
	gTextColor = ::GetSysColor(COLOR_WINDOWTEXT);
	m_TextColor.Format("RGB( %d, %d, %d )",
		gTextColor & 0x000000FF,
		(gTextColor & 0x0000FF00) >> 8,
		(gTextColor & 0x00FF0000) >> 16
		);
	m_FileName = "";
	m_ImageSize = "";
	UpdateData(FALSE);

	P->CreateWallPaper(1,NULL,(char*)(const char*)m_FileName,0);
	P->Invalidate();
}

/*
HBRUSH CCustomizeDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;
}
*/
